package edu.mermet.tp8.fenetres;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Properties;
import javax.swing.text.PlainDocument;
import java.io.FileReader;
import edu.mermet.tp8.Application;
import java.util.ResourceBundle;
import java.util.HashMap;

public class JDialogCommentFaire extends JDialog {

	private Application appli;
	
	private HashMap<String, String> hmTextes;
	private HashMap<String, String> hmTitres;
	private DefaultListModel dlm = new DefaultListModel();

	private JList liste = new JList();
	private JEditorPane desc = new JTextPane();


	public JDialogCommentFaire(Application appli){
		super(appli, "Comment Faire ?", false);
		this.appli = appli;
		init();
	}

	private void init(){
		chercherProperties();

		//Initialisation de la liste d'aide
		for(String cleTitre : hmTitres.keySet()){
			dlm.addElement(hmTitres.get(cleTitre));
			System.out.println(hmTitres.get(cleTitre));
		}

		//Génération de la fenêtre
		liste.setModel(dlm);
		liste.addMouseListener(new ActionListe());
		desc.setContentType("text/html");
        desc.setEditable(false);
		JSplitPane pnlPrincipal = new JSplitPane(SwingConstants.VERTICAL, liste, desc);
		add(pnlPrincipal);

		setSize(200,200);
		show();
		addWindowListener(new EcouteurFermeture());
	}

	private void chercherProperties(){
		ResourceBundle resTitre = ResourceBundle.getBundle("HowTo.titres");
		ResourceBundle resTexte = ResourceBundle.getBundle("HowTo.textes");

		hmTitres = new HashMap<String, String>();
		for(String titre : resTitre.keySet()){
			hmTitres.put(titre, resTitre.getString(titre));
			//System.out.println(titre + " " + resTitre.getString(titre));
		}
		hmTextes = new HashMap<String, String>();
		for(String titre : resTexte.keySet()){
			hmTextes.put(titre, resTexte.getString(titre));
			//System.out.println(titre + " " + resTexte.getString(titre));
		}
	}

	class EcouteurFermeture extends WindowAdapter{

        public void windowClosing(WindowEvent e){
            appli.enableCommentFaire(true);
        }
    }

    private class ActionListe implements MouseListener {

        @Override
        public void mouseClicked(MouseEvent e) {
            System.out.println(liste.getSelectedValue());
            String val = liste.getSelectedValue().toString();
            for(String cle : hmTitres.keySet()){
            	if(hmTitres.get(cle).equals(val)){
            		desc.setText(hmTextes.get(cle));
            	}
            }

        }
        @Override
        public void mouseExited(MouseEvent e){}
        @Override
        public void mouseEntered(MouseEvent e){}
        @Override
        public void mouseReleased(MouseEvent e){}
        @Override
        public void mousePressed(MouseEvent e){}
    }
}